VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3420
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7290
   LinkTopic       =   "Form1"
   ScaleHeight     =   3420
   ScaleWidth      =   7290
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Tabla clientes"
      Height          =   2655
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   7095
      Begin MSComctlLib.ListView ListView1 
         Height          =   2295
         Left            =   240
         TabIndex        =   2
         Top             =   240
         Width           =   6495
         _ExtentX        =   11456
         _ExtentY        =   4048
         LabelWrap       =   -1  'True
         HideSelection   =   0   'False
         FullRowSelect   =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Cargar tabla"
      Height          =   375
      Left            =   5400
      TabIndex        =   0
      Top             =   2880
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' \\ Declaraciones ( Apis )
' ------------------------------------------------------------------------------------------
Private Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Private Declare Sub InitCommonControls Lib "Comctl32" ()


' -- Declaracin Api SendMessage
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const LVM_SETCOLUMNWIDTH = &H101E

' -- Variables para la Base de datos y el Recordset de ADO
Dim rst As ADODB.Recordset
Dim db As ADODB.Connection

Private Sub Autosize_Columns(lv As ListView)
    Dim i As Integer
    ' -- Autoajustar encabezados
    For i = 0 To lv.ColumnHeaders.Count - 1
        SendMessage lv.hwnd, LVM_SETCOLUMNWIDTH, i, -3
    Next i
End Sub

Public Sub Recordset_a_ListView( _
    ByRef rst As ADODB.Recordset, _
    ByRef ListView As ListView, _
    sValue As Variant, _
    Optional lColor As Long = vbBlue)
    
    On Error GoTo errSub
    
    Dim i As Integer, k As Integer, iColumna As Integer, vt() As Long
    Dim st() As Single, w() As Long, t As Long, LVitem As ListItem
    
    ListView.ListItems.Clear

    If rst.State = adStateOpen Then
       
       If Not (rst.BOF And rst.EOF) Then
          ListView.View = lvwReport
            iColumna = rst.Fields.Count - 1
            ReDim w(0 To iColumna)
            ReDim st(0 To iColumna)
            ReDim vt(0 To iColumna)


            For i = 0 To iColumna
                If rst(i).DefinedSize > 9 Then
                    w(i) = rst(i).DefinedSize
                Else
                    w(i) = 10
                End If
                t = t + w(i)
            Next
            For i = 0 To iColumna
                st(i) = w(i) / t
                vt(i) = rst.Fields(i).Type
            Next

            
            If ListView.ColumnHeaders.Count = 0 Then
            For i = 0 To iColumna
               ListView.ColumnHeaders.Add , , rst.Fields(i).Name, _
                                          ListView.Width * st(i)
            Next
            
            Else
            For i = 0 To iColumna
                ListView.ColumnHeaders(i + 1).Width = ListView.Width * st(i)
            Next
            End If
            rst.MoveFirst

            While Not rst.EOF
            
               If vt(0) = adBoolean Then
                  If rst.Fields(0).Value = vbFalse Then
                     Set LVitem = ListView.ListItems.Add(, , "NO")
                  Else
                     Set LVitem = ListView.ListItems.Add(, , "YES")
                  End If
               Else
                     Set LVitem = ListView.ListItems.Add(, , rst.Fields(0).Value)
               End If

               If iColumna > 0 Then

               For k = 1 To iColumna
                   If vt(k) = adBoolean Then
                      If rst.Fields(k).Value = vbFalse Then
                         LVitem.ListSubItems.Add , , "NO"
                       Else
                         LVitem.ListSubItems.Add , , "YES"
                       End If
                   Else
                       If IsNull(rst.Fields(k).Value) Then
                          LVitem.ListSubItems.Add , , ""
                       Else
                          LVitem.ListSubItems.Add , , rst.Fields(k).Value
                          If Trim(LCase(rst.Fields(k).Value)) = Trim(LCase(sValue)) Then
                             LVitem.ForeColor = lColor
                          End If
                       End If
                   End If
               Next
               End If
               
               rst.MoveNext
            Wend
            
            ListView.Sorted = True
            ListView.SortKey = 0
        End If
        End If

        db.Close
        Set rst = Nothing
        
        Call Autosize_Columns(ListView1)
    Exit Sub
errSub:
    MsgBox Err.Number & " " & Err.Description, vbCritical
    db.Close
    Set rst = Nothing
End Sub

'Enviar en esta funcin el Recordset y el Control ListView
Private Sub Command1_Click()
    Call Recordset_a_ListView(rst, ListView1, "Representante de ventas", vbBlue)
End Sub

Private Sub Form_Load()
  
  Dim ruta          As String
  Dim tabla         As String
  
  Set db = New ADODB.Connection

  ruta = "C:\Archivos de programa\Microsoft Visual Studio\VB98\nwind.mdb"
  db.CursorLocation = adUseClient
  
  'IMPORTANTE:
  'Especificar la Ruta de la base de datos y la cadena de conexin necesaria
  db.Open "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" & ruta & ";"

  Set rst = New Recordset
  
  'IMPORTANTE:
  'Especificar la Consulta
  tabla = "[Clientes]"
  rst.Open "SELECT NombreContacto,CargoContacto,Telfono,Fax FROM " & tabla, db, adOpenStatic, adLockOptimistic
  
End Sub
Private Sub Form_Initialize()
    Call SetErrorMode(2)
    Call InitCommonControls
End Sub
